image: cccma/canesm-docker

stages:
  - merge
  - lint
  - build
#  - regression

variables:
  BUILD_CACHE: $CI_PROJECT_DIR/builds/
  BUILDER: $CI_PROJECT_DIR/external-ci/build-ci.py
  INTEGRATOR: $CI_PROJECT_DIR/external-ci/integrate-ci.py
  UPSTREAM_BRANCH: develop_canesm

merge_upstream:
  before_script: &setup_upstream
    - git submodule update --init --recursive > /dev/null
    - git remote add upstream https://gitlab.com/cccma/canesm.git
    - git submodule foreach --recursive 'git remote add upstream https://gitlab.com/cccma/$(basename $name).git'
    - git fetch upstream > /dev/null
    - git submodule foreach --recursive "git fetch upstream" > /dev/null
  stage: merge
  script:
    - git merge upstream/$UPSTREAM_BRANCH 
        || { echo "Automatic merging failed - Merging of $UPSTREAM_BRANCH must be done manually."; exit 1;}
    - git submodule foreach --recursive "git merge upstream/$UPSTREAM_BRANCH" 
        || { echo "Automatic merging failed - Merging of $UPSTREAM_BRANCH must be done manually."; exit 1;}

lint:
  before_script:    
    - git submodule update --init --recursive > /dev/null
  stage: lint
  script:
    - cd CanAM
    - python ../CCCma_tools/linter/fast.py

build:
  before_script: &merge_upstream
    - *setup_upstream
    - mkdir $BUILD_CACHE
    - git merge upstream/$UPSTREAM_BRANCH
    - git submodule foreach --recursive "git merge upstream/$UPSTREAM_BRANCH"
    - export PYTHONPATH=$PYTHONPATH:$CI_PROJECT_DIR/external-ci
  stage: build
  artifacts:
    paths:
      - $BUILD_CACHE/
    expire_in: 1 week
  script:
    - python3.8 $BUILDER $BUILD_CACHE $CI_PROJECT_DIR ubuntu_container piControl 4 6

# Comment this out for now since only compilation is being tested using the Gitlab shared runner
#regression:
#  before_script:
#    - export PYTHONPATH=$PYTHONPATH:$CI_PROJECT_DIR/external-ci
#  stage: regression
#  script:
#    - python3.8 $INTEGRATOR $BUILD_CACHE $CI_PROJECT_DIR ubuntu_container piControl 4 6
